﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.IO;
using System.Threading;

namespace mscommtest
{
    public partial class Form1 : Form
    {
      //  private byte[] rcvData;
        private byte[] sendData;
      
       Boolean lampon = false;
       Boolean lampoff = false;
       Boolean lampbright = false;
       Boolean lampdim = false;

        Thread serverThread = null;

        public Form1()
        {
            InitializeComponent();
            serialPort1.Open();
            Thread.Sleep(1000);
            serverThread = new Thread(new ThreadStart(ServerWorker));
            serverThread.Start();
        }

        private void ServerWorker(){
            try
            {
                bool preState = false;
                while (true)
                {
                    System.Net.WebClient web = new System.Net.WebClient();
                    System.IO.StreamReader reader = new StreamReader(web.OpenRead("http://siio.jp/~students/lamplog1.txt"));
                    String s = reader.ReadToEnd();
                    reader.Close();
                    web.Dispose();
                    if (s == "0")
                    {
                        //   textBox1.Text = "OK";
                        if (preState)
                        {

                            sendData = new byte[6];
                            sendData[0] = 0x02;
                            serialPort1.Write(sendData, 0, 1);

                            Thread.Sleep(1);


                            sendData[1] = 0x63;
                            sendData[2] = 0x46;
                            sendData[3] = 0x4C;
                            sendData[4] = 0x47;
                            sendData[5] = 0x41;



                            serialPort1.Write(sendData, 1, 5);
                            preState = false;
                        }

                    }
                    else
                    {
                        if (!preState)
                        {
                            sendData = new byte[6];
                            sendData[0] = 0x02;
                            serialPort1.Write(sendData, 0, 1);

                            Thread.Sleep(1);


                            sendData[1] = 0x63;
                            sendData[2] = 0x46;
                            sendData[3] = 0x4C;
                            sendData[4] = 0x45;
                            sendData[5] = 0x41;


                            serialPort1.Write(sendData, 1, 5);
                            preState = true;
                        }
                    }
                }
            }
            catch (ThreadAbortException ex)
            {

            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.ToString());
            }
        }

        private void connectbutton_Click(object sender, EventArgs e)
        {

         //   sendData = new byte[50];
         //   sendData[0] = 0x02;

         //   serialPort1.Write(sendData, 0, 1);


        
        }

        int connect_cnt1 = 0, connect_cnt2 = 0;
        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            
          //  rcvData = new byte[5];
          //serialPort1.Read(rcvData, 0, 4);
          //  string data = serialPort1.ReadExisting();
           // string data = serialPort1.ReadLine();
           // MessageBox.Show(data);
           // serialPort1.NewLine = @"\r";
           // string data = serialPort1.ReadLine();
           // MessageBox.Show(data);
          byte[] rcvData = new byte[5];

          int cnt = 0;
          while (cnt < rcvData.Length)
          {
              byte b = (byte)serialPort1.ReadByte();
              if (b != 0x00)
              {
                  rcvData[cnt] = b;
                  cnt++;
              }
          }

          CheckForIllegalCrossThreadCalls = false;

          if (rcvData[2] == 67)
          {
            //  lampon = true;
              textBox1.Text = "lampon" + connect_cnt1.ToString();
              connect_cnt1++;

              
         //     System.Net.WebClient web = new System.Net.WebClient();
           //   web.CachePolicy = System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore;
           //   web.CachePolicy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore);

            //  System.IO.Stream stream = web.OpenRead("http://192.168.108.2/~students/lampwrite1.php?state=1");


            //  System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore);
            //  System.Net.HttpWebRequest.DefaultCachePolicy = policy;

//              System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Refresh);
              System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
              HttpWebRequest.DefaultCachePolicy = policy;

              HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://siio.jp/~students/lampwrite2.php?state=1");
              WebResponse res = req.GetResponse();
              res.Close();
              
          }
          else if(rcvData[2] == 65)
          {
              textBox2.Text = "lampoff" + connect_cnt2.ToString();
              connect_cnt2++;
             // System.Net.WebClient web = new System.Net.WebClient();
            //  web.CachePolicy = System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore;
           //   web.CachePolicy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore);

            //  System.IO.Stream stream = web.OpenRead("http://192.168.108.2/~students/lampwrite1.php?state=0");

         //     System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.NoCacheNoStore);
         //     System.Net.HttpWebRequest.DefaultCachePolicy = policy;


             // System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Refresh);
              System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
              HttpWebRequest.DefaultCachePolicy = policy;

              HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://siio.jp/~students/lampwrite2.php?state=0");
              WebResponse res = req.GetResponse();
              res.Close();
          }


              //    Thread.Sleep(10);

              //    if(rcvData[2] == 31 && rcvData[7] == 0x47)
              //   {
              //    lampoff = true;
              //  textBox1.Text = "lampon";
              //}
              //else if(rcvData[2] == "31" && rcvData[7] == "45")
              // {
              //   lampon = true;
              //  textBox1.Text = "lampoff";
              // }
              // else if(rcvData[2] == "4B")
              // {
              //   lampbright = true;
              // textBox1.Text = "lampbright";
              // }

              // else if(rcvData[2] == "49")
              // {
              //   lampdim = true;
              //   textBox1.Text = "lampdim";
              //  }

              //            textBox1.Text = rcvData[2].ToString();
              //            MessageBox.Show(rcvData[2].ToString());

  //            CheckForIllegalCrossThreadCalls = false;
    //        textBox1.Text = rcvData[0].ToString();
      //      textBox2.Text = rcvData[1].ToString();
        //    textBox3.Text = rcvData[2].ToString();
          //  textBox4.Text = rcvData[3].ToString();
            //textBox5.Text = rcvData[4].ToString();

//            rcvData = null;

//            textBox1.Text = "hello";
            //   textBox1.Text = rcvData[7].ToString();

        }

        private void button1_Click(object sender, EventArgs e)
        {
          //  if lampon = false;
//return;
            sendData = new byte[6];
            sendData[0] = 0x02;
            serialPort1.Write(sendData, 0, 1);

            Thread.Sleep(2);


            sendData[1] = 0x63;
            sendData[2] = 0x46;
            sendData[3] = 0x4C;
            sendData[4] = 0x45;
            sendData[5] = 0x41;

            serialPort1.Write(sendData, 1, 5);
            //   string url = "http://192.168.108.2/~students/lampwrite1.php?state=1";
            //   HttpWebRequest req = WebRequest.Create(url) as HttpWebRequest;
            //  HttpWebResponse res = null;
            //   try
            // {
            //   res = req.GetResponse() as HttpWebResponse;
            // textBox1.Text = "OK";
            //}
            // catch
            //{
            //  textBox1.Text = "エラー";
            // return;
            //}
            System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
            HttpWebRequest.DefaultCachePolicy = policy;

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://siio.jp/~students/lampwrite2.php?state=1");
            WebResponse res = req.GetResponse();
            res.Close();

           // System.Net.WebClient web = new System.Net.WebClient();
           // System.IO.Stream stream = web.OpenRead("http://192.168.108.2/~students/lampwrite1.php?state=1");
            //   System.IO.StreamReader sr = new System.IO.StreamReader(stream);
            //   textBox1.Text = sr.ReadToEnd();

        }

        private void button2_Click(object sender, EventArgs e)
        {

            sendData = new byte[6];
            sendData[0] = 0x02;
            serialPort1.Write(sendData, 0, 1);

            Thread.Sleep(2);

            sendData[1] = 0x63;
            sendData[2] = 0x46;
            sendData[3] = 0x4C;
            sendData[4] = 0x47;
            sendData[5] = 0x41;

            serialPort1.Write(sendData, 1, 5);

            System.Net.Cache.HttpRequestCachePolicy policy = new System.Net.Cache.HttpRequestCachePolicy(System.Net.Cache.HttpRequestCacheLevel.Reload);
            HttpWebRequest.DefaultCachePolicy = policy;

            HttpWebRequest req = (HttpWebRequest)WebRequest.Create("http://siio.jp/~students/lampwrite2.php?state=0");
            WebResponse res = req.GetResponse();
            res.Close();

       //     System.Net.WebClient web = new System.Net.WebClient();
       //     System.IO.Stream stream = web.OpenRead("http://192.168.108.2/~students/lampwrite1.php?state=0");
            //    System.IO.StreamReader sr = new System.IO.StreamReader(stream);
            //    textBox1.Text = sr.ReadToEnd();

        }

        private void readtxt_Click(object sender, EventArgs e)
        {
            System.Net.WebClient web = new System.Net.WebClient();
            System.IO.Stream stream = web.OpenRead("http://192.168.108.2/~students/lamplog1.txt");
            System.IO.StreamReader sr = new System.IO.StreamReader(stream);
            String s = sr.ReadToEnd();
            if (s == "0")
            {
                //   textBox1.Text = "OK";

                sendData[11] = 0x63;
                sendData[12] = 0x46;
                sendData[13] = 0x5C;
                sendData[14] = 0x47;
                sendData[15] = 0x41;

                serialPort1.Write(sendData, 11, 5);
            }
            else
            {
                sendData[16] = 0x63;
                sendData[17] = 0x46;
                sendData[18] = 0x5C;
                sendData[19] = 0x45;
                sendData[20] = 0x41;

                serialPort1.Write(sendData, 16, 5);
            }
        }

        private void state_Click(object sender, EventArgs e)
        {
            sendData[21] = 0x63;
            sendData[22] = 0x46;
            sendData[23] = 0x4C;
            sendData[24] = 0x51;
            sendData[25] = 0x41;

            serialPort1.Write(sendData, 21, 5);
        }
    }
}